import{s as ft,n as mt,o as pt}from"../chunks/scheduler.d6170356.js";import{S as gt,i as ct,g as n,s as a,r as u,A as yt,h as r,f as o,c as s,j as dt,u as d,x as l,k as ht,y as vt,a as i,v as h,d as f,t as m,w as p}from"../chunks/index.fcd4cc08.js";import{H as c,E as wt}from"../chunks/EditOnGithub.da2b595c.js";function bt(Ee){let g,ee,X,te,y,oe,v,Se="At Hugging Face our intent is to provide the AI community with <strong>free storage space for public repositories</strong>. We do bill for storage space for <strong>private repositories</strong>, above a free tier (see table below).",ie,w,Ge='We <a href="https://huggingface.co/blog/xethub-joins-hf" rel="nofollow">optimize our infrastructure</a> continuously to <a href="https://x.com/julien_c/status/1821540661973160339" rel="nofollow">scale our storage</a> for the coming years of growth in Machine learning.',ae,b,Ae="We do have mitigations in place to prevent abuse of free public storage, and in general we ask users and organizations to make sure any uploaded large model or dataset is <strong>as useful to the community as possible</strong> (as represented by numbers of likes or downloads, for instance).",se,$,ne,T,Re="<thead><tr><th>Type of account</th> <th>Public storage</th> <th>Private storage</th></tr></thead> <tbody><tr><td>Free user or org</td> <td>Best-effort* 🙏</td> <td>100GB</td></tr> <tr><td>PRO</td> <td>Unlimited ✅</td> <td>1TB + pay-as-you-go</td></tr> <tr><td>Enterprise Hub</td> <td>Unlimited ✅</td> <td>1TB per seat + pay-as-you-go</td></tr></tbody>",re,x,Ue="💡 Enterprise Hub includes 1TB of private storage per seat in the subscription: for example, if your organization has 40 members, then you have 40TB of included private storage.",le,H,Oe="*We aim to continue providing the AI community with free storage space for public repositories, please don’t abuse and upload dozens of TBs of generated anime 😁. If possible, we still ask that you consider upgrading to PRO and/or Enterprise Hub whenever possible.",ue,C,de,_,Ne='Above the included 1TB (or 1TB per seat) of private storage in PRO and Enterprise Hub, private storage is invoiced at <strong>$25/TB/month</strong>, in 1TB increments. See our <a href="./billing">billing doc</a> for more details.',he,k,fe,L,De=`In parallel to storage limits at the account (user or organization) level, there are some limitations to be aware of when dealing with a large amount of data in a specific repo. Given the time it takes to stream the data,
getting an upload/push to fail at the end of the process or encountering a degraded experience, be it on hf.co or when working locally, can be very annoying. In the following section, we describe our recommendations on how to best structure your large repos.`,me,P,pe,M,Ye='We gathered a list of tips and recommendations for structuring your repo. If you are looking for more practical tips, check out <a href="https://huggingface.co/docs/huggingface_hub/main/en/guides/upload#tips-and-tricks-for-large-uploads" rel="nofollow">this guide</a> on how to upload large amount of data using the Python library.',ge,B,Je="<thead><tr><th>Characteristic</th> <th>Recommended</th> <th>Tips</th></tr></thead> <tbody><tr><td>Repo size</td> <td>-</td> <td>contact us for large repos (TBs of data)</td></tr> <tr><td>Files per repo</td> <td>&lt;100k</td> <td>merge data into fewer files</td></tr> <tr><td>Entries per folder</td> <td>&lt;10k</td> <td>use subdirectories in repo</td></tr> <tr><td>File size</td> <td>&lt;20GB</td> <td>split data into chunked files</td></tr> <tr><td>Commit size</td> <td>&lt;100 files*</td> <td>upload files in multiple commits</td></tr> <tr><td>Commits per repo</td> <td>-</td> <td>upload multiple files per commit and/or squash history</td></tr></tbody>",ce,z,Ke="<em>* Not relevant when using <code>git</code> CLI directly</em>",ye,q,Qe="Please read the next section to understand better those limits and how to deal with them.",ve,I,we,F,Ve=`What are we talking about when we say “large uploads”, and what are their associated limitations? Large uploads can be
very diverse, from repositories with a few huge files (e.g. model weights) to repositories with thousands of small files
(e.g. an image dataset).`,be,W,Xe=`Under the hood, the Hub uses Git to version the data, which has structural implications on what you can do in your repo.
If your repo is crossing some of the numbers mentioned in the previous section, <strong>we strongly encourage you to check out <a href="https://github.com/github/git-sizer" rel="nofollow"><code>git-sizer</code></a></strong>,
which has very detailed documentation about the different factors that will impact your experience. Here is a TL;DR of factors to consider:`,$e,j,Ze=`<li><strong>Repository size</strong>: The total size of the data you’re planning to upload. We generally support repositories up to 300GB. If you would like to upload more than 300 GBs (or even TBs) of data, you will need to ask us to grant more storage. To do that, please send an email with details of your project to <a href="mailto:datasets@huggingface.co">datasets@huggingface.co</a> (for datasets) or <a href="mailto:models@huggingface.co">models@huggingface.co</a> (for models).</li> <li><strong>Number of files</strong>:<ul><li>For optimal experience, we recommend keeping the total number of files under 100k, and ideally much less. Try merging the data into fewer files if you have more.
For example, json files can be merged into a single jsonl file, or large datasets can be exported as Parquet files or in <a href="https://github.com/webdataset/webdataset" rel="nofollow">WebDataset</a> format.</li> <li>The maximum number of files per folder cannot exceed 10k files per folder. A simple solution is to
create a repository structure that uses subdirectories. For example, a repo with 1k folders from <code>000/</code> to <code>999/</code>, each containing at most 1000 files, is already enough.</li></ul></li> <li><strong>File size</strong>: In the case of uploading large files (e.g. model weights), we strongly recommend splitting them <strong>into chunks of around 20GB each</strong>.
There are a few reasons for this:<ul><li>Uploading and downloading smaller files is much easier both for you and the other users. Connection issues can always
happen when streaming data and smaller files avoid resuming from the beginning in case of errors.</li> <li>Files are served to the users using CloudFront. From our experience, huge files are not cached by this service
leading to a slower download speed.
In all cases no single LFS file will be able to be &gt;50GB. I.e. 50GB is the hard limit for single file size.</li></ul></li> <li><strong>Number of commits</strong>: There is no hard limit for the total number of commits on your repo history. However, from
our experience, the user experience on the Hub starts to degrade after a few thousand commits. We are constantly working to
improve the service, but one must always remember that a git repository is not meant to work as a database with a lot of
writes. If your repo’s history gets very large, it is always possible to squash all the commits to get a
fresh start using <code>huggingface_hub</code>’s <a href="https://huggingface.co/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.super_squash_history" rel="nofollow"><code>super_squash_history</code></a>. Be aware that this is a non-revertible operation.</li> <li><strong>Number of operations per commit</strong>: Once again, there is no hard limit here. When a commit is uploaded on the Hub, each
git operation (addition or delete) is checked by the server. When a hundred LFS files are committed at once,
each file is checked individually to ensure it’s been correctly uploaded. When pushing data through HTTP,
a timeout of 60s is set on the request, meaning that if the process takes more time, an error is raised. However, it can
happen (in rare cases) that even if the timeout is raised client-side, the process is still
completed server-side. This can be checked manually by browsing the repo on the Hub. To prevent this timeout, we recommend
adding around 50-100 files per commit.</li>`,Te,E,xe,S,et="One key way Hugging Face supports the machine learning ecosystem is by hosting datasets on the Hub, including very large ones. However, if your dataset is bigger than 300GB, you will need to ask us to grant more storage.",He,G,tt='In this case, to ensure we can effectively support the open-source ecosystem, we require you to let us know via <a href="mailto:datasets@huggingface.co">datasets@huggingface.co</a>.',Ce,A,ot="When you get in touch with us, please let us know:",_e,R,it="<li>What is the dataset, and who/what is it likely to be useful for?</li> <li>The size of the dataset.</li> <li>The format you plan to use for sharing your dataset.</li>",ke,U,at="For hosting large datasets on the Hub, we require the following for your dataset:",Le,O,st='<li>A dataset card: we want to ensure that your dataset can be used effectively by the community and one of the key ways of enabling this is via a dataset card. This <a href="./datasets-cards.md">guidance</a> provides an overview of how to write a dataset card.</li> <li>You are sharing the dataset to enable community reuse. If you plan to upload a dataset you anticipate won’t have any further reuse, other platforms are likely more suitable.</li> <li>You must follow the repository limitations outlined above.</li> <li>Using file formats that are well integrated with the Hugging Face ecosystem. We have good support for <a href="https://huggingface.co/docs/datasets/v2.19.0/en/loading#parquet" rel="nofollow">Parquet</a> and <a href="https://huggingface.co/docs/datasets/v2.19.0/en/loading#webdataset" rel="nofollow">WebDataset</a> formats, which are often good options for sharing large datasets efficiently. This will also ensure the dataset viewer works for your dataset.</li> <li>Avoid the use of custom loading scripts when using datasets. In our experience, datasets that require custom code to use often end up with limited reuse.</li>',Pe,N,nt="Please get in touch with us if any of these requirements are difficult for you to meet because of the type of data or domain you are working in.",Me,D,Be,Y,rt="Similarly to datasets, if you host models bigger than 300GB or if you plan on uploading a large number of smaller sized models (for instance, hundreds of automated quants) totalling more than 1TB, you will need to ask us to grant more storage.",ze,J,lt='To do that, to ensure we can effectively support the open-source ecosystem, please send an email with details of your project to <a href="mailto:models@huggingface.co">models@huggingface.co</a>.',qe,K,Ie,Q,ut='If you need more model/ dataset storage than your allocated private storage for academic/ research purposes, please reach out to us at <a href="mailto:datasets@huggingface.co">datasets@huggingface.co</a> or <a href="mailto:models@huggingface.co">models@huggingface.co</a> along with a proposal of how you will use the storage grant.',Fe,V,We,Z,je;return y=new c({props:{title:"Storage limits",local:"storage-limits",headingTag:"h1"}}),$=new c({props:{title:"Storage plans",local:"storage-plans",headingTag:"h2"}}),C=new c({props:{title:"Pay-as-you-go price",local:"pay-as-you-go-price",headingTag:"h3"}}),k=new c({props:{title:"Repository limitations and recommendations",local:"repository-limitations-and-recommendations",headingTag:"h2"}}),P=new c({props:{title:"Recommendations",local:"recommendations",headingTag:"h3"}}),I=new c({props:{title:"Explanations",local:"explanations",headingTag:"h3"}}),E=new c({props:{title:"Sharing large datasets on the Hub",local:"sharing-large-datasets-on-the-hub",headingTag:"h3"}}),D=new c({props:{title:"Sharing large volumes of models on the Hub",local:"sharing-large-volumes-of-models-on-the-hub",headingTag:"h3"}}),K=new c({props:{title:"Grants for private repositories",local:"grants-for-private-repositories",headingTag:"h3"}}),V=new wt({props:{source:"https://github.com/huggingface/hub-docs/blob/main/docs/hub/storage-limits.md"}}),{c(){g=n("meta"),ee=a(),X=n("p"),te=a(),u(y.$$.fragment),oe=a(),v=n("p"),v.innerHTML=Se,ie=a(),w=n("p"),w.innerHTML=Ge,ae=a(),b=n("p"),b.innerHTML=Ae,se=a(),u($.$$.fragment),ne=a(),T=n("table"),T.innerHTML=Re,re=a(),x=n("p"),x.textContent=Ue,le=a(),H=n("p"),H.textContent=Oe,ue=a(),u(C.$$.fragment),de=a(),_=n("p"),_.innerHTML=Ne,he=a(),u(k.$$.fragment),fe=a(),L=n("p"),L.textContent=De,me=a(),u(P.$$.fragment),pe=a(),M=n("p"),M.innerHTML=Ye,ge=a(),B=n("table"),B.innerHTML=Je,ce=a(),z=n("p"),z.innerHTML=Ke,ye=a(),q=n("p"),q.textContent=Qe,ve=a(),u(I.$$.fragment),we=a(),F=n("p"),F.textContent=Ve,be=a(),W=n("p"),W.innerHTML=Xe,$e=a(),j=n("ul"),j.innerHTML=Ze,Te=a(),u(E.$$.fragment),xe=a(),S=n("p"),S.textContent=et,He=a(),G=n("p"),G.innerHTML=tt,Ce=a(),A=n("p"),A.textContent=ot,_e=a(),R=n("ul"),R.innerHTML=it,ke=a(),U=n("p"),U.textContent=at,Le=a(),O=n("ul"),O.innerHTML=st,Pe=a(),N=n("p"),N.textContent=nt,Me=a(),u(D.$$.fragment),Be=a(),Y=n("p"),Y.textContent=rt,ze=a(),J=n("p"),J.innerHTML=lt,qe=a(),u(K.$$.fragment),Ie=a(),Q=n("p"),Q.innerHTML=ut,Fe=a(),u(V.$$.fragment),We=a(),Z=n("p"),this.h()},l(e){const t=yt("svelte-u9bgzb",document.head);g=r(t,"META",{name:!0,content:!0}),t.forEach(o),ee=s(e),X=r(e,"P",{}),dt(X).forEach(o),te=s(e),d(y.$$.fragment,e),oe=s(e),v=r(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1u4ialb"&&(v.innerHTML=Se),ie=s(e),w=r(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-1494v6m"&&(w.innerHTML=Ge),ae=s(e),b=r(e,"P",{"data-svelte-h":!0}),l(b)!=="svelte-jgzlaj"&&(b.innerHTML=Ae),se=s(e),d($.$$.fragment,e),ne=s(e),T=r(e,"TABLE",{"data-svelte-h":!0}),l(T)!=="svelte-1th72q8"&&(T.innerHTML=Re),re=s(e),x=r(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-14e761s"&&(x.textContent=Ue),le=s(e),H=r(e,"P",{"data-svelte-h":!0}),l(H)!=="svelte-14vlefo"&&(H.textContent=Oe),ue=s(e),d(C.$$.fragment,e),de=s(e),_=r(e,"P",{"data-svelte-h":!0}),l(_)!=="svelte-1o1yd27"&&(_.innerHTML=Ne),he=s(e),d(k.$$.fragment,e),fe=s(e),L=r(e,"P",{"data-svelte-h":!0}),l(L)!=="svelte-d6x2wb"&&(L.textContent=De),me=s(e),d(P.$$.fragment,e),pe=s(e),M=r(e,"P",{"data-svelte-h":!0}),l(M)!=="svelte-1lth8r8"&&(M.innerHTML=Ye),ge=s(e),B=r(e,"TABLE",{"data-svelte-h":!0}),l(B)!=="svelte-1tj7sge"&&(B.innerHTML=Je),ce=s(e),z=r(e,"P",{"data-svelte-h":!0}),l(z)!=="svelte-1kqloz8"&&(z.innerHTML=Ke),ye=s(e),q=r(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-4yld6t"&&(q.textContent=Qe),ve=s(e),d(I.$$.fragment,e),we=s(e),F=r(e,"P",{"data-svelte-h":!0}),l(F)!=="svelte-ojgmzx"&&(F.textContent=Ve),be=s(e),W=r(e,"P",{"data-svelte-h":!0}),l(W)!=="svelte-1sfy0e"&&(W.innerHTML=Xe),$e=s(e),j=r(e,"UL",{"data-svelte-h":!0}),l(j)!=="svelte-jv80m7"&&(j.innerHTML=Ze),Te=s(e),d(E.$$.fragment,e),xe=s(e),S=r(e,"P",{"data-svelte-h":!0}),l(S)!=="svelte-1sotakv"&&(S.textContent=et),He=s(e),G=r(e,"P",{"data-svelte-h":!0}),l(G)!=="svelte-1mp2cp6"&&(G.innerHTML=tt),Ce=s(e),A=r(e,"P",{"data-svelte-h":!0}),l(A)!=="svelte-19o549b"&&(A.textContent=ot),_e=s(e),R=r(e,"UL",{"data-svelte-h":!0}),l(R)!=="svelte-198ryst"&&(R.innerHTML=it),ke=s(e),U=r(e,"P",{"data-svelte-h":!0}),l(U)!=="svelte-7ilaqr"&&(U.textContent=at),Le=s(e),O=r(e,"UL",{"data-svelte-h":!0}),l(O)!=="svelte-1o54rjz"&&(O.innerHTML=st),Pe=s(e),N=r(e,"P",{"data-svelte-h":!0}),l(N)!=="svelte-124ey02"&&(N.textContent=nt),Me=s(e),d(D.$$.fragment,e),Be=s(e),Y=r(e,"P",{"data-svelte-h":!0}),l(Y)!=="svelte-1jsvm3u"&&(Y.textContent=rt),ze=s(e),J=r(e,"P",{"data-svelte-h":!0}),l(J)!=="svelte-16yvmcy"&&(J.innerHTML=lt),qe=s(e),d(K.$$.fragment,e),Ie=s(e),Q=r(e,"P",{"data-svelte-h":!0}),l(Q)!=="svelte-bjroyd"&&(Q.innerHTML=ut),Fe=s(e),d(V.$$.fragment,e),We=s(e),Z=r(e,"P",{}),dt(Z).forEach(o),this.h()},h(){ht(g,"name","hf:doc:metadata"),ht(g,"content",$t)},m(e,t){vt(document.head,g),i(e,ee,t),i(e,X,t),i(e,te,t),h(y,e,t),i(e,oe,t),i(e,v,t),i(e,ie,t),i(e,w,t),i(e,ae,t),i(e,b,t),i(e,se,t),h($,e,t),i(e,ne,t),i(e,T,t),i(e,re,t),i(e,x,t),i(e,le,t),i(e,H,t),i(e,ue,t),h(C,e,t),i(e,de,t),i(e,_,t),i(e,he,t),h(k,e,t),i(e,fe,t),i(e,L,t),i(e,me,t),h(P,e,t),i(e,pe,t),i(e,M,t),i(e,ge,t),i(e,B,t),i(e,ce,t),i(e,z,t),i(e,ye,t),i(e,q,t),i(e,ve,t),h(I,e,t),i(e,we,t),i(e,F,t),i(e,be,t),i(e,W,t),i(e,$e,t),i(e,j,t),i(e,Te,t),h(E,e,t),i(e,xe,t),i(e,S,t),i(e,He,t),i(e,G,t),i(e,Ce,t),i(e,A,t),i(e,_e,t),i(e,R,t),i(e,ke,t),i(e,U,t),i(e,Le,t),i(e,O,t),i(e,Pe,t),i(e,N,t),i(e,Me,t),h(D,e,t),i(e,Be,t),i(e,Y,t),i(e,ze,t),i(e,J,t),i(e,qe,t),h(K,e,t),i(e,Ie,t),i(e,Q,t),i(e,Fe,t),h(V,e,t),i(e,We,t),i(e,Z,t),je=!0},p:mt,i(e){je||(f(y.$$.fragment,e),f($.$$.fragment,e),f(C.$$.fragment,e),f(k.$$.fragment,e),f(P.$$.fragment,e),f(I.$$.fragment,e),f(E.$$.fragment,e),f(D.$$.fragment,e),f(K.$$.fragment,e),f(V.$$.fragment,e),je=!0)},o(e){m(y.$$.fragment,e),m($.$$.fragment,e),m(C.$$.fragment,e),m(k.$$.fragment,e),m(P.$$.fragment,e),m(I.$$.fragment,e),m(E.$$.fragment,e),m(D.$$.fragment,e),m(K.$$.fragment,e),m(V.$$.fragment,e),je=!1},d(e){e&&(o(ee),o(X),o(te),o(oe),o(v),o(ie),o(w),o(ae),o(b),o(se),o(ne),o(T),o(re),o(x),o(le),o(H),o(ue),o(de),o(_),o(he),o(fe),o(L),o(me),o(pe),o(M),o(ge),o(B),o(ce),o(z),o(ye),o(q),o(ve),o(we),o(F),o(be),o(W),o($e),o(j),o(Te),o(xe),o(S),o(He),o(G),o(Ce),o(A),o(_e),o(R),o(ke),o(U),o(Le),o(O),o(Pe),o(N),o(Me),o(Be),o(Y),o(ze),o(J),o(qe),o(Ie),o(Q),o(Fe),o(We),o(Z)),o(g),p(y,e),p($,e),p(C,e),p(k,e),p(P,e),p(I,e),p(E,e),p(D,e),p(K,e),p(V,e)}}}const $t='{"title":"Storage limits","local":"storage-limits","sections":[{"title":"Storage plans","local":"storage-plans","sections":[{"title":"Pay-as-you-go price","local":"pay-as-you-go-price","sections":[],"depth":3}],"depth":2},{"title":"Repository limitations and recommendations","local":"repository-limitations-and-recommendations","sections":[{"title":"Recommendations","local":"recommendations","sections":[],"depth":3},{"title":"Explanations","local":"explanations","sections":[],"depth":3},{"title":"Sharing large datasets on the Hub","local":"sharing-large-datasets-on-the-hub","sections":[],"depth":3},{"title":"Sharing large volumes of models on the Hub","local":"sharing-large-volumes-of-models-on-the-hub","sections":[],"depth":3},{"title":"Grants for private repositories","local":"grants-for-private-repositories","sections":[],"depth":3}],"depth":2}],"depth":1}';function Tt(Ee){return pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class _t extends gt{constructor(g){super(),ct(this,g,Tt,bt,ft,{})}}export{_t as component};
